clear all;clc;close all;
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% Load image
file_name    = 'lena.bmp';
cover_object = imread(file_name);
% Load watermark
file_name = 'copyright.bmp';
img       = imread(file_name);
message   = im2bw(img,0.5);
% Watermark embedding
[watermarked_image,watermarkingdata] = embedding(cover_object,message);
% Save watermarked image on disk
imwrite(watermarked_image,'watermarked_image.bmp','bmp');
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% Load the watermarked image
file_name         = 'watermarked_image.bmp';
watermarked_image = imread(file_name);
% Add noise
corrupted_image = imnoise(watermarked_image,'salt & pepper',0.01);
corrupted_image = imrotate(corrupted_image,22,'crop');
% Watermark detection
recmessage  = detecting(corrupted_image,watermarkingdata);
% Visualization
figure,subplot(1,2,1),imshow(recmessage),title('Recovered Watermark');
subplot(1,2,2),imshow(message),title('Original Watermark');
% Performance evaluation
figure,
subplot(1,3,1),imshow(cover_object),title('Original Image'),
subplot(1,3,2),imshow(watermarked_image),title('Watermarked Image'),
subplot(1,3,3),imshow(corrupted_image),title('Corrupted Image'),